/*********************
ESP8266 as a TCP Servicer
*********************/

#include <SoftwareSerial.h>
#define DEBUG true
#define SSID "elecrow"  // your ssid
#define PASS "elecrow2014" //pass word
SoftwareSerial sofSerial(2,3); 
void setup()
{
  sofSerial.begin(9600);
  Serial.begin(115200); // your esp's baud rate might be different
 
  sendData("AT+CWMODE=3\r\n",1000,DEBUG); // configure as access point 
  sendData("AT+RST\r\n",2000,DEBUG); // reset module
 
       //connect to the wifi
       boolean connected=false;
       for(int i=0;i<5;i++)
       {
           if(connectWiFi())
           {
               connected = true;
                   break;
             }
         }
         if (!connected){while(1);}
         delay(2000);
         
  sendData("AT+CIFSR\r\n",1000,DEBUG); // get ip address
  sendData("AT+CIPMUX=1\r\n",1000,DEBUG); // configure for multiple connections
  sendData("AT+CIPSERVER=1,80\r\n",1000,DEBUG); // turn on server on port 80
}
 
void loop()
{
  if(Serial.available()) // check if the esp is sending a message 
  {
    
/*    while(Serial.available())
    {
      // The esp has data so display its output to the serial window 
      char c = Serial.read(); // read the next character.
      sofSerial.write(c);
    } 
    */
    if(Serial.find("+IPD,"))
    {
     delay(1000);
 
     int connectionId = Serial.read()-48; // subtract 48 because the read() function returns 
                                           // the ASCII decimal value and 0 (the first decimal number) starts at 48
     
     String webpage = "<h1>Hello</h1>";
 
     String cipSend = "AT+CIPSEND=";
     cipSend += connectionId;
     cipSend += ",";
     cipSend +=webpage.length();
     cipSend +="\r\n";
     
     sendData(cipSend,1000,DEBUG);
     sendData(webpage,1000,DEBUG);

     String closeCommand = "AT+CIPCLOSE="; 
     closeCommand+=5;
     closeCommand+="\r\n";
     sendData(closeCommand,3000,DEBUG);
    }
  }
}
 
 
String sendData(String command, const int timeout, boolean debug)
{
    String response = "";
    
    Serial.print(command); // send the read character to the Serial
    
    long int time = millis();
    
    while( (time+timeout) > millis())
    {
      while(Serial.available())
      {
        
        // The esp has data so display its output to the serial window 
        char c = Serial.read(); // read the next character.
        response+=c;
      }  
    }
    
    if(debug)
    {
      sofSerial.print(response);
    }
    
    return response;
}

boolean connectWiFi()
{
       String cmd="AT+CWJAP=\"";
       cmd+=SSID;
       cmd+="\",\"";
       cmd+=PASS;
       cmd+="\"";
       Serial.println(cmd);
       Serial.println(cmd);
       delay(3000);
       if(Serial.find("OK"))
     {
          sofSerial.println("OK, Connected to WiFi.");
     return true;
     }else
     {
           sofSerial.println("Can not connect to the WiFi.");
           return false;
     }
}
